import 'package:_private_chat/utils/utils.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

import 'package:get/get.dart' as getx;
import 'package:get/get.dart';
import 'package:_private_core/_private_core.dart';

import '../bloc/chat_detail_bloc.dart';
import '../chat_detail_screen.dart';
import '../message.dart';

ChatDetailBloc get _chatDetailBloc => Get.find<ChatDetailBloc>();

class WidgetInputChat extends StatelessWidget {
  final ChatDetailParams params;
  final Widget Function(dynamic state, TextEditingController controller,
      FocusNode node, Function() onSend, bool isBot)? builder;

  const WidgetInputChat({
    Key? key,
    required this.params,
    this.builder,
  }) : super(key: key);

  TextEditingController get controller => _chatDetailBloc.inputController;
  FocusNode get inputFocus => _chatDetailBloc.inputFocus;

  void onSend() {
    if (controller.text.trim().isNotEmpty) {
      _chatDetailBloc.add(ChatSendMessageEvent(
          type: MessageType.text, text: controller.text.trim()));
      controller.clear();
    }
  }

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ChatDetailBloc, ChatDetailState>(
      bloc: _chatDetailBloc,
      builder: (_, state) {
        return builder?.call(
                state, controller, inputFocus, onSend, params.isBot) ??
            currentChatOptions.chatDetailInputBuilder(
                state, controller, inputFocus, onSend, params.isBot);
      },
    );
  }
}
