import 'package:_private_chat/utils/utils.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart'; 
import 'package:get/get.dart';
import 'package:_private_chat/_private_chat.dart'; 

ChatDetailBloc get _chatDetailBloc => Get.find<ChatDetailBloc>();

class WidgetProfileChat extends StatelessWidget {
  final ChatDetailParams params;
  final Widget Function(dynamic state, bool isBot)? builder;
  const WidgetProfileChat({
    Key? key,
    required this.params,
    this.builder,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ChatDetailBloc, ChatDetailState>(
      bloc: _chatDetailBloc,
      builder: (_, state) {
        return KeyedSubtree(
          key: ValueKey(state.isLoading),
          child: builder?.call(state, params.isBot) ??
              currentChatOptions.chatDetailProfileBuilder(state, params.isBot),
        );
      },
    );
  }
}
